/**
 * DevExtreme (integration/jquery/events.js)
 * Version: 17.2.0 (build 17206)
 * Build date: Tue Jul 25 2017
 *
 * Copyright (c) 2012 - 2017 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var $ = require("jquery");
var eventsEngine = require("../../events/core/events_engine");
var useJQueryRenderer = false !== window.useJQueryRenderer;
if (useJQueryRenderer) {
    eventsEngine.set({
        on: function(element) {
            $(element).on.apply($(element), Array.prototype.slice.call(arguments, 1))
        },
        one: function(element) {
            $(element).one.apply($(element), Array.prototype.slice.call(arguments, 1))
        },
        off: function(element) {
            $(element).off.apply($(element), Array.prototype.slice.call(arguments, 1))
        },
        trigger: function(element) {
            $(element).trigger.apply($(element), Array.prototype.slice.call(arguments, 1))
        }
    })
}
